//*************************************
//          Reichel Bartosz
//          reichel@mif.pg.gda.pl
//          http://reichel.pl 
//          2006.08.19
//*************************************
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    FParent:THandle;
  public
    { Public declarations }
    procedure CreateParams(var Params:TCreateParams);override;
    constructor CreateP(Parent:THandle);virtual;
  end;

var
  Form1: TForm1;

implementation
uses WinSock;
{$R *.dfm}

function IPAddrToName(IPAddr: string): string;
var
  SockAddrIn: TSockAddrIn;
  HostEnt: PHostEnt;
  WSAData: TWSAData;
begin
  WSAStartup($101, WSAData);
  SockAddrIn.sin_addr.s_addr:=inet_addr(PChar(IPAddr));
  HostEnt:= GetHostByAddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
  if HostEnt<>nil then
  begin
    Result := StrPas(Hostent^.h_name)
  end
  else
  begin
    Result:='';
  end;
end;


function LocalIP : string;
type
    TaPInAddr = array [0..10] of PInAddr;
    PaPInAddr = ^TaPInAddr;
var
    phe  : PHostEnt;
    pptr : PaPInAddr;
    Buffer : array [0..63] of char;
    I    : Integer;
    GInitData      : TWSADATA;

begin
    WSAStartup($101, GInitData);
    Result := '';
    GetHostName(Buffer, SizeOf(Buffer));
    phe := GetHostByName(buffer);
    if phe = nil then Exit;
    pptr := PaPInAddr(Phe^.h_addr_list);
    I := 0;
    while pptr^[I] <> nil do begin
      result := result + StrPas(inet_ntoa(pptr^[I]^)) +'  '+ IPAddrToName(StrPas(inet_ntoa(pptr^[I]^)))+#13#10;
      Inc(I);
    end;

    WSACleanup;
end;


constructor TForm1.CreateP(Parent:THandle);
begin
  FParent := Parent;
  inherited Create(nil);
end;

procedure TForm1.CreateParams(var Params:TCreateParams);
begin
 inherited CreateParams(Params);
 Params.WndParent := FParent;
 //chcemy aby nasza wtyczka byla dzieckiem okna podanego
 //jako parametr (tu zakladka TTabSheet)
 Params.Style := WS_CHILD or WS_CLIPSIBLINGS;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
 LIP:String;
begin
 LIP := LocalIP;
 Label1.Caption:= LIP;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//gdy okno jest zamykane zwalniamy pamiec
 action := caFree;
end;

end.
