{reichel bart
reichel@rudy.mif.pg.gda.pl}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MyInterface;

type
  TSuperForma = class(TForm)
    Shape1: TShape;
    Button1: TButton;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FParent:THandle;
    Ap:IPlugsApplication;
  public
    { Public declarations }
    procedure CreateParams(var Params:TCreateParams);override;
    constructor CreateP(Parent:THandle;dAp:IPlugsApplication);virtual;
  end;

var
  SuperForma: TSuperForma;

implementation

{$R *.dfm}
constructor TSuperForma.CreateP(Parent:THandle;dAp:IPlugsApplication);
begin
  FParent := Parent;
  Ap := dAp;
  inherited Create(nil);
end;

procedure TSuperForma.CreateParams(var Params:TCreateParams);
begin
 inherited CreateParams(Params);
 Params.WndParent := FParent;
 Params.Style := WS_CHILD or WS_CLIPSIBLINGS or WS_BORDER;
end;

procedure TSuperForma.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//na koniec uwalniamy okno
 action := caFree;
end;

procedure TSuperForma.Button1Click(Sender: TObject);
begin
 if ColorDialog1.Execute then
 begin
  if assigned(ap) then
   ap.ChangeColor( ColorDialog1.Color);
 end;
end;

end.
